Name:          openwebbeans
Version:       1.2.0
Release:       7%{?dist}
Summary:       Implementation of the JSR-299 WebBeans
License:       ASL 2.0
URL:           http://openwebbeans.apache.org/
Source0:       http://www.apache.org/dist/openwebbeans/%{version}/%{name}-%{version}-source-release.zip

Patch0:        %{name}-1.2.0-servlet31.patch
Patch1:        %{name}-1.2.0-xbean-312.patch
# Add missing tomcat7 method
Patch2:        %{name}-1.2.0-tomcat7.patch
Patch3:        %{name}-1.2.0-interceptors-1.2-api.patch

BuildRequires: maven-local
BuildRequires: mvn(asm:asm)
BuildRequires: mvn(asm:asm-commons)
BuildRequires: mvn(com.google.code.maven-replacer-plugin:replacer)
BuildRequires: mvn(javax.annotation:javax.annotation-api) >= 1.2
BuildRequires: mvn(javax.el:javax.el-api)
BuildRequires: mvn(javax.enterprise:cdi-api)
BuildRequires: mvn(javax.inject:javax.inject)
BuildRequires: mvn(javax.servlet:javax.servlet-api)
BuildRequires: mvn(javax.servlet.jsp:javax.servlet.jsp-api)
BuildRequires: mvn(junit:junit)
BuildRequires: mvn(org.apache:apache:pom:)
BuildRequires: mvn(org.apache:apache-jar-resource-bundle)
BuildRequires: mvn(org.apache.felix:maven-bundle-plugin)
BuildRequires: mvn(org.apache.geronimo.specs:geronimo-ejb_3.1_spec)
BuildRequires: mvn(org.apache.geronimo.specs:geronimo-jcdi_1.0_spec)
BuildRequires: mvn(org.apache.geronimo.specs:geronimo-jms_1.1_spec)
BuildRequires: mvn(org.apache.geronimo.specs:geronimo-jta_1.1_spec)
BuildRequires: mvn(org.apache.geronimo.specs:geronimo-validation_1.0_spec)
BuildRequires: mvn(org.apache.geronimo.specs:specs:pom:)
BuildRequires: mvn(org.apache.httpcomponents:project:pom:)
BuildRequires: mvn(org.apache.maven.plugins:maven-dependency-plugin)
BuildRequires: mvn(org.apache.maven.plugins:maven-release-plugin)
BuildRequires: mvn(org.apache.maven.plugins:maven-remote-resources-plugin)
BuildRequires: mvn(org.apache.tomcat:tomcat-catalina)
BuildRequires: mvn(org.apache.xbean:xbean-finder)
BuildRequires: mvn(org.codehaus.mojo:build-helper-maven-plugin)
BuildRequires: mvn(org.eclipse.osgi:org.eclipse.osgi)
BuildRequires: mvn(org.hibernate.javax.persistence:hibernate-jpa-2.0-api)
BuildRequires: mvn(org.jboss.shrinkwrap:shrinkwrap-api)
BuildRequires: mvn(org.jboss.spec.javax.faces:jboss-jsf-api_2.2_spec)
BuildRequires: mvn(org.jboss.spec.javax.interceptor:jboss-interceptors-api_1.2_spec)
BuildRequires: mvn(org.ow2.asm:asm-all)

%if 0
# 2015-07-29: Retired because it depends on shrinkwrap-resolver which did not...
BuildRequires: mvn(org.jboss.shrinkwrap.resolver:shrinkwrap-resolver-bom)
BuildRequires: mvn(org.jboss.arquillian:arquillian-bom)
BuildRequires: mvn(org.jboss.arquillian.container:arquillian-container-spi)
BuildRequires: mvn(org.jboss.arquillian.core:arquillian-core-spi)
BuildRequires: mvn(org.jboss.arquillian.junit:arquillian-junit-container)
BuildRequires: mvn(org.jboss.arquillian.test:arquillian-test-spi)
BuildRequires: mvn(org.jboss.arquillian.testenricher:arquillian-testenricher-cdi)
%endif

#BuildRequires: apache-rat-plugin
#BuildRequires: maven-doxia
#BuildRequires: maven-doxia-modules
#BuildRequires: mvn(org.apache.maven.doxia:doxia-module-fml)
#BuildRequires: mvn(org.apache.maven.doxia:doxia-module-xhtml)

Obsoletes:     %{name}-arquillian

BuildArch:     noarch

%description
OpenWebBeans is an implementation of the JSR-299, Contexts and
Dependency Injection for the Java EE platform.

It also already incorporates some features which are part of JSR-346
but doesn't need API changes as we still use the JCDI-1.0 API. The
incorporated CDI-1.1 features are mostly parts which are not well defined
in the CDI-1.0 specification, like Serialisation checks, etc.

%package cdi11
Summary:       OpenWebBeans Core for CDI 1.1

%description cdi11
Apache OpenWebBeans Implementation core module implementing CDI 1.1.

%package clustering
Summary:       Apache OpenWebBeans Clustering Plugin

%description clustering
Apache OpenWebBeans Clustering plugin.

%package ee
Summary:       Apache OpenWebBeans Java EE plugin

%description ee
Apache OpenWebBeans Java EE Utility.

%package ee-common
Summary:       Apache OpenWebBeans EE Common plugin

%description ee-common
Apache OpenWebBeans Java EE Common.

%package ejb
Summary:       Apache OpenWebBeans EJB plugin

%description ejb
Apache OpenWebBeans Java EE EJB plugin.

%package el22
Summary:       Apache OpenWebBeans EL 2.2 plugin

%description el22
Apache OpenWebBeans EL 2.2 integration.

%package impl
Summary:       Apache OpenWebBeans Core

%description impl
Apache OpenWebBeans Implementation core module.

%package jee5-ejb-resource
Summary:       Apache OpenWebBeans EE Resource plugin

%description jee5-ejb-resource
Apache OpenWebBeans EE 5 Resource Integration.

%package jms
Summary:       Apache OpenWebBeans JMS plugin

%description jms
Apache OpenWebBeans JMS Integration.

%package jsf
Summary:       Apache OpenWebBeans JSF-2 plugin

%description jsf
Apache OpenWebBeans JSF integration.

%package osgi
Summary:       Apache OpenWebBeans OSGi plugin

%description osgi
Apache OpenWebBeans OSGi ClassLoader scanning support.

%package resource
Summary:       Apache OpenWebBeans EE Resource plugin

%description resource
Apache OpenWebBeans EE Resource Integration.

%package spi
Summary:       Apache OpenWebBeans SPI definition

%description spi
Apache OpenWebBeans Service Provider Interfaces.

%package test
Summary:       Apache OpenWebBeans CDI Test Framework

%description test
This package contains testing support for CDI containers and
also provides an implementation for OpenWebBeans.

%package tomcat7
Summary:       Apache OpenWebBeans Tomcat 7 plugin

%description tomcat7
ApacheOpenWebBeans Tomcat 7 Web Profile.

%package web
Summary:       Apache OpenWebBeans Web plugin

%description web
Apache OpenWebBeans Java EE Web and Serlvet plugin.

%package javadoc
Summary:       Javadoc for %{name}

%description javadoc
This package contains javadoc for %{name}.

%prep
%setup -q

%patch0 -p1
%patch1 -p0
%patch2 -p0
%patch3 -p1

rm -r DEPENDENCIES
# require org.apache.openwebbeans.build-tools checkstyle-rules 1.2
%pom_remove_plugin :maven-checkstyle-plugin
%pom_remove_plugin :findbugs-maven-plugin
%pom_remove_plugin :taglist-maven-plugin
%pom_remove_plugin -r :maven-source-plugin
# Use for generate webbeans-cdi11
%pom_add_plugin org.apache.maven.plugins:maven-source-plugin:2.1.2 webbeans-impl "
<executions>
  <execution>
    <goals>
      <goal>jar</goal>
    </goals>
  </execution>
</executions>"

# unavailable deps
%pom_disable_module distribution
%pom_disable_module samples
%pom_disable_module webbeans-doc
%pom_disable_module webbeans-el10
%pom_disable_module webbeans-jsf12
# TODO
# org.apache.openejb openejb-core
# org.apache.openejb openejb-core openejb-tomcat-catalina 3.1.4
# org.jboss.jsr299.tck jsr299-tck-api 1.0.4.CR1
%pom_disable_module webbeans-porting
# org.jboss.jsr299.tck jsr299-tck-impl 1.0.4.SP1
%pom_disable_module webbeans-tck
%pom_disable_module atinject-tck
%pom_disable_module webbeans-tomcat6
# Retired
%pom_disable_module webbeans-arquillian
%pom_remove_dep :arquillian-bom webbeans-arquillian

%pom_add_dep asm:asm webbeans-cdi11
%pom_change_dep :geronimo-annotation_1.2_spec javax.annotation:javax.annotation-api webbeans-cdi11
%pom_change_dep :geronimo-atinject_1.0_spec javax.inject:javax.inject webbeans-cdi11
%pom_change_dep :geronimo-el_2.2_spec javax.el:javax.el-api:3.0.0 webbeans-cdi11
%pom_change_dep :geronimo-interceptor_1.1_spec org.jboss.spec.javax.interceptor:jboss-interceptors-api_1.2_spec webbeans-cdi11
%pom_change_dep :geronimo-jcdi_1.1_spec javax.enterprise:cdi-api:1.1 webbeans-cdi11
%pom_change_dep org.apache.xbean:xbean-finder-shaded org.apache.xbean:xbean-finder webbeans-cdi11

%pom_change_dep -r :geronimo-annotation_1.1_spec javax.annotation:javax.annotation-api
%pom_change_dep -r :geronimo-atinject_1.0_spec javax.inject:javax.inject
%pom_change_dep -r :geronimo-el_2.2_spec javax.el:javax.el-api:3.0.0
%pom_change_dep -r :geronimo-interceptor_1.1_spec org.jboss.spec.javax.interceptor:jboss-interceptors-api_1.2_spec
%pom_change_dep -r :geronimo-jpa_2.0_spec org.hibernate.javax.persistence:hibernate-jpa-2.0-api
%pom_change_dep -r :geronimo-jsp_2.1_spec javax.servlet.jsp:javax.servlet.jsp-api:2.3.2-b01
%pom_change_dep -r :geronimo-servlet_2.5_spec javax.servlet:javax.servlet-api:3.1.0
%pom_change_dep -r :myfaces-api org.jboss.spec.javax.faces:jboss-jsf-api_2.2_spec
%pom_change_dep -r :org.osgi.core org.eclipse.osgi:org.eclipse.osgi

%pom_change_dep -r org.apache.xbean:xbean-finder-shaded org.apache.xbean:xbean-finder
%pom_add_dep asm:asm webbeans-impl
# java.lang.ClassNotFoundException: org.objectweb.asm.commons.EmptyVisitor
%pom_add_dep asm:asm-commons::test webbeans-impl
sed -i "s|org.apache.xbean.asm|org.objectweb.asm|" \
 webbeans-impl/src/main/java/org/apache/webbeans/proxy/AbstractProxyFactory.java \
 webbeans-impl/src/main/java/org/apache/webbeans/proxy/InterceptorDecoratorProxyFactory.java \
 webbeans-impl/src/main/java/org/apache/webbeans/proxy/NormalScopeProxyFactory.java \
 webbeans-impl/src/main/java/org/apache/webbeans/proxy/SubclassProxyFactory.java
# java.lang.ClassNotFoundException: org.objectweb.asm.commons.EmptyVisitor
%pom_add_dep asm:asm-commons::test webbeans-el22
%pom_add_dep asm:asm-commons::test webbeans-web
# java.lang.ClassNotFoundException: org.objectweb.asm.commons.EmptyVisitor
# java.lang.NoClassDefFoundError org/apache/xbean/finder/AnnotationFinder$InfoBuildingVisitor
%pom_add_dep asm:asm-commons::test webbeans-clustering
%pom_add_dep org.apache.xbean:xbean-finder::test webbeans-clustering

# fix replacer plugin configuration (jira OWB-892)
%pom_xpath_remove "pom:project/pom:build/pom:plugins/pom:plugin[pom:artifactId = 'replacer']/pom:configuration" webbeans-cdi11
%pom_xpath_inject "pom:project/pom:build/pom:plugins/pom:plugin[pom:artifactId = 'replacer']" '
<configuration>
  <basedir>${basedir}</basedir>
  <preserveDir>true</preserveDir>
  <includes>
    <include>target/generated-sources/**/*.java</include>
  </includes>
  <replacements>
    <replacement>
        <token>import org.apache.webbeans.component.spi.BeanAttributes</token>
        <value>import javax.enterprise.inject.spi.BeanAttributes</value>
    </replacement>
    <replacement>
        <token>import org.apache.webbeans.component.spi.ProducerFactory</token>
        <value>import javax.enterprise.inject.spi.ProducerFactory</value>
    </replacement>
    <replacement>
        <token>import org.apache.webbeans.component.spi.InjectionTargetFactory</token>
        <value>import javax.enterprise.inject.spi.InjectionTargetFactory</value>
    </replacement>
  </replacements>
</configuration>' webbeans-cdi11

# These test fails
# java.lang.OutOfMemoryError: unable to create new native thread
rm -r webbeans-impl/src/test/java/org/apache/webbeans/portable/AnnotatedTypeImplTest.java
# require servlet 2.5 apis
rm -rf webbeans-clustering/src/test/java/org/apache/webbeans/web/failover/tests/MockServletContext.java \
 webbeans-clustering/src/test/java/org/apache/webbeans/web/failover/tests/MockServletRequest.java

# Break build
%pom_remove_plugin org.apache.rat:apache-rat-plugin

# merge parents poms with proper project subpackage
#%%  org.apache.openwebbeans.arquillian: arquillian
%mvn_package org.apache.openwebbeans.test: test

%mvn_package :%{name}-impl::tests: %{name}-impl
%mvn_package :%{name}-impl::sources: __noinstall

%build

# some tests fails, e.g. :
# java.lang.NoClassDefFoundError: Could not fully load class: org.apache.webbeans.newtests.interceptors.resolution.beans.UtilitySampleBean
# due to:org/apache/xbean/finder/AnnotationFinder$InfoBuildingVisitor
# java.lang.NoClassDefFoundError: Could not fully load class: org.apache.webbeans.test.component.library.BookShop
# due to:org/objectweb/asm/commons/EmptyVisitor
# require xbean-finder-shaded

%mvn_build -s -- -Pcdi-1.1 \
  -Dproject.build.sourceEncoding=UTF-8 \
  -Dmaven.test.failure.ignore=true

%install
%mvn_install

%files -f .mfiles-%{name}
%license LICENSE NOTICE

%files cdi11 -f .mfiles-%{name}-cdi11
%license LICENSE NOTICE

%files clustering -f .mfiles-%{name}-clustering
%license LICENSE NOTICE

%files ee -f .mfiles-%{name}-ee
%license LICENSE NOTICE

%files ee-common -f .mfiles-%{name}-ee-common
%license LICENSE NOTICE

%files ejb -f .mfiles-%{name}-ejb
%license LICENSE NOTICE

%files el22 -f .mfiles-%{name}-el22
%license LICENSE NOTICE

%files impl -f .mfiles-%{name}-impl
%license LICENSE NOTICE

%files jee5-ejb-resource -f .mfiles-%{name}-jee5-ejb-resource
%license LICENSE NOTICE

%files jms -f .mfiles-%{name}-jms
%license LICENSE NOTICE

%files jsf -f .mfiles-%{name}-jsf
%license LICENSE NOTICE

%files osgi -f .mfiles-%{name}-osgi
%license LICENSE NOTICE

%files resource -f .mfiles-%{name}-resource
%license LICENSE NOTICE

%files spi -f .mfiles-%{name}-spi
%license LICENSE NOTICE

%files test -f .mfiles-test
%license LICENSE NOTICE

%files tomcat7 -f .mfiles-%{name}-tomcat7
%license LICENSE NOTICE

%files web -f .mfiles-%{name}-web
%license LICENSE NOTICE

%files javadoc -f .mfiles-javadoc
%license LICENSE NOTICE

%changelog
* Thu Jul 30 2015 gil cattaneo <puntogil@libero.it> 1.2.0-7
- disable arquillian support

* Fri Jun 19 2015 gil cattaneo <puntogil@libero.it> 1.2.0-6
- use interceptors 1.2 apis

* Thu Jun 18 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.2.0-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Wed Feb 11 2015 gil cattaneo <puntogil@libero.it> 1.2.0-4
- introduce license macro

* Sat Jun 07 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.2.0-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Fri Mar 28 2014 Michael Simacek <msimacek@redhat.com> - 1.2.0-2
- Use Requires: java-headless rebuild (#1067528)

* Fri Aug 16 2013 gil cattaneo <puntogil@libero.it> 1.2.0-1
- update to 1.2.0

* Tue Jul 23 2013 gil cattaneo <puntogil@libero.it> 1.1.8-4
- used geronimo-jcdi-1.0-api, for avoid conflicts with new cdi-api 1.1

* Thu Jul 11 2013 gil cattaneo <puntogil@libero.it> 1.1.8-3
- built with XMvn
- adapt to current guideline

* Wed May 15 2013 gil cattaneo <puntogil@libero.it> 1.1.8-2
- added jpackage-utils references

* Tue May 07 2013 gil cattaneo <puntogil@libero.it> 1.1.8-1
- update to 1.1.8
- disable tomcat6 module

* Fri Dec 21 2012 gil cattaneo <puntogil@libero.it> 1.1.7-1
- update to 1.1.7

* Wed Oct 24 2012 gil cattaneo <puntogil@libero.it> 1.1.6-1
- initial rpm
